/*
Copyright (C) 1996,1997,1998,1999 Didier VIDAL

This file is part of Scheme With Types, herein refered as SWiT.

SWiT is free software; you can redistribute it and/or modify it under
the terms of the GNU LIBRARY GENERAL PUBLIC LICENSE as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

SWiT is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
License for more details.

You should have received a copy of the GNU Library General Public License
along with SWiT software; see the file COPYING.
If not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/*==================================================================
 *           DEFINITION AND CONSTRUCTION OF QUADS
 *==================================================================
 */
#define SWIT_QUAD(obj) ((struct SWiT_Quad *)((obj)->data))
#define QUAD_X(obj) ((obj)->x)
#define QUAD_Y(obj) ((obj)->y)
#define QUAD_Z(obj) ((obj)->z)
#define QUAD_W(obj) ((obj)->w)

struct SWiT_Quad
{
  double x,y,z,w;
};
typedef struct SWiT_Quad *SWiT_Quad;

/* Exported */
double to_double (SWiT arg);
SWiT_Quad make_quad (double x, double y, double z, double w);
SWiT swit_make_quad (SWiT_Quad q);
SWiT quad_copy_prim (SWiT arg);
SWiT_Quad pt_line (SWiT_Quad p1, SWiT_Quad p2, double t);
double pts_distance (SWiT_Quad p1, SWiT_Quad p2);
unsigned int swit_vect3_type(SWiT x);
unsigned int swit_point_type(SWiT x);

