.if t .ps 12p
.if t .vs 13p
.de CR
.it 1 an-trap
.ft C
.if \\n[.$] \&\\$*
..
.ba 1c
.TH SWIT 1 "November 1998" "swit version 0.96.0" \" -*- nroff -*-
.ti 0
\l'\n(.lu'
.SH NAME
swit \- scheme language with polymorphic types
.SH SYNOPSIS
.B swit
[
.IR scheme-file
]

.SH DESCRIPTION
The scheme language is fully described in
the ``Revised\u\s-14\s0\d Report on the Algorithmic Language Scheme''
(R4RS for short in the following).

\fBswit\fR uses GNU \fIreadline/history library\fR for interactive input.
The garbage collector is the \fIconservative garbage collector\fR
of Hans-J. Boehm et al. ``Bignums'' have been implemented with
GNU \fIgmp library\fR.

\fBswit\fR is distributed under the GNU Public Library Licence.
It is free software, you can redistribute it and/or modify it
as long as the authorship and the copyright are mentioned.
In particular, \fBswit\fR is distributed
WITHOUT ANY WARRANTY. Enjoy it AT YOUR OWN RISK.
See the file COPYING for more details.

.SH OPTIONS
A file name can be given in the command line and will be loaded after
initialisation is completed.
.br
Moreover, unless a file \fC.switinitrc\fR exists in your home
directory, the file \fCswitinitrc\fR found in the swit library 
(by default in \fC/usr/local/lib/swit\fR
or in the place pointed by the shell variable \fCSWIT_LIBRARY_PATH\fR),
it will be loaded before the file that is (possibly) given on the
command line. 

.SH GLOBAL VARIABLES
.vs
.TP
.BI \(**type\(**\ \ \ \fI<bool>\fR
Its boolean value triggers the typing algorithm. Default is \fC#t\fR.
.TP
.BI \(**verbose\(**\ \ \ \fI<bool>\fP
If \fC#t\fR, the evaluation time of interactive commands and names
of functions or macros being defined when loading files are
displayed. The default is \fC#f\fR.
.TP
.BI \(**time\(**\ \ \ \fI<integer>\fP
After each interactive command, the CPU time of its evaluation is
assigned to this variable.
.TP
.BI \(**load-path\(**\ \ \ \fI<string>\fP
See its use below at the description of the command \fCload\fP.
.TP
.BI \(**prompt\(**\ \ \ \fI<string>\fP
Change it if you don't like the default ``> ''.
When some parens are missing in interactive mode (and the command
is not complete), a ``secondary'' prompt is displayed as the
number of missing parens followed by the primary prompt. When
too many close parens are entered, a (read) error will occur.
.TP
.BI \(**print-depth\(**\ \ \ \fI<integer>\fP
Prints \fC..\fP (two dots) when the maximum depth is
reached. The default is \fC20\fR. Disabled when loading a file.
.TP
.BI \(**print-length\(**\ \ \ \fI<integer>\fP
Prints \fC....\fP (four dots) when the maximum length of a list
is reached. The default is \fC20\fR. Disabled when loading a file.
.TP
.BI \(**print-cycle\(**\ \ \ \fI<bool>\fP
When \fC#t\fP, expressions are printed as graphs (cycles and shared
sub-expressions are detected). The default is \fC#f\fR.
.TP
.BI \(**inline\(**\ \ \ \fI<bool>\fP
This variable is used by the compiler to replace symbols naming a
primitive by the primitive itself. When \fC#t\fP (the default),
if the value of such a symbol is changed afterward this will not
affect the function.
.TP
.BI \(**empty-list\(**\ \ \ \fI<bool>\fP
This variable is used by the compiler. When \fC#t\fP (the default),
the empty list need not be quoted. R4RS requires that the empty list
should be quoted, but this point rarely followed in most implementations.
.TP
.BI \(**strip\(**\ \ \ \fI<bool>\fP
This variable is used by the compiler. When \fC#f\fP (the default),
the name of the formals are kept in environments. Disabling this
feature has no consequence for functional programming (except that
disassembling will be less readable or impossible). On the contrary,
the object system needs these names for message passing.
.TP
.BI \(**keywords\(**\ \ \ \fI<bool>\fP
This variable is used by the compiler. When \fC#f\fP (the default),
keywords can be used as variables.

\fIRefers to the inline-documentation to get all information about
the bluid-in functions and constructs of this implementation.\fP

.SH BUGS

\fIDisassembling:\fP
.br
Environments are not disassembled.

\fIImplementation limits:\fP
.br
They should be defined and the programmer should be made aware of them.

\fIError handling:\fP
.br
Signals handling is poorly implemented. Error reporting is not yet
quite satisfactory.
.br

\fINumbers :\fP
.br
Some domain and range errors of operations on inexact numbers are not
properly handled.
.br

\fIComments or reports on bugs and problems are welcome !\fR

To report a bug, please make a log-file from the start of the
session until the bug appears, send that file to
vidal@lip6.fr and possibly join your comments or suggestions.

.SH CREDITS
At the very beginning of this work, the Libscheme-0.5 implementation
from Brent Benson was a precious guide.
.br
The idea to make a simple interface with Tcl/Tk was originated
(I beleive) by Kathi Fisler in her Schemepkg0.1.

.SH VERSION
The latest version can be retrieved from : ftp.lip6.fr://jussieu/softs/lip6/swit/

.SH AUTHOR
The author can be reached by e-mail: Didier.VIDAL@oberon.ufr-info-p6.jussieu.fr

or mail at:

        Didier VIDAL
        LIP6
        Universite\*' Pierre et Marie-Curie
        4, place Jussieu
        F-75252 PARIS Cedex 05
        FRANCE
